/*
  Copyright 1999-2004 The Apache Software Foundation

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

      http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
*/

/**
 * @version $Id: flow.js 293104 2005-10-02 12:41:05Z jeremy $
 */

importClass(Packages.java.util.Calendar);


var resolver = cocoon.getComponent(org.apache.excalibur.source.SourceResolver.ROLE);

function fileBrowserSuggest() {
    var prefix = "context://samples/";
    var filename = cocoon.request.getParameter("filename");
    
    var src = resolver.resolveURI(prefix + filename);
    var suggestions = new java.util.ArrayList();
    if (src.exists() && src.isCollection()) {
        var children = src.children;
        if (!filename.endsWith('/')) filename += "/";
        suggestions.add(filename);
        for (var i = 0; i < children.size(); i++) {
            suggestions.add(filename + children.get(i).getName());
        }
    } else {
        var parent = src.parent;
        var children = parent.children;
        if (filename.indexOf('/') != -1) {
            filename = filename.substring(0, filename.lastIndexOf('/') + 1);
        } else {
            filename = "";
        }
        for (var i = 0; i < children.size(); i++) {
            var child = children.get(i);
            if (child.name.startsWith(src.name))
                suggestions.add(filename + children.get(i).getName());
        }
    }
    
    cocoon.sendPage("display-suggestions", { suggestions: suggestions, selection: cocoon.request.getParameter("filename")});
    
}

function timedUpdateDemo() {
	var calendar = Calendar.getInstance();
	var data = {
		time: calendar.getTime(),
		hour: calendar.get(Calendar.HOUR_OF_DAY),
		 min: calendar.get(Calendar.MINUTE),
		rand: Math.random()
	};
	cocoon.sendPage("timed-updater-screen", {data: data});
}